#include <iostream>
#include <cmath>

using namespace std;

int main()
{
    int n,m,c,zbir=0,x,rez;
    cin>>n>>m;
    int b[m];
    for(int k=1;k<=m;k++)
    {
        cin>>b[k];
    }
    cin>>c;
    int a[n];
    for(int p=1;p<=n;p++)
    {
        a[p]=p;
    }
    int niz[n-m+1];
    for(int i=0;i<=n-m;i++)
    {
        niz[i]=i;
        x=i;
        for(int j=1; j<=m; j++)
        {
           a[x + b[j]] = a[x + j];
        }
    }
    for(int i=1;i<=n;i++)
    {
        zbir=zbir+(pow(c,i)*(a[i]));
    }
    rez=zbir%998244353;
    cout<<rez;
    return 0;
}